
#######################################################################################
################################# 1 - Pre-preparation: ################################
#######################################################################################

#* Have established that the self-employed aren't included in this variable:
svytable(~ Dat$variables$jbmngr + Dat$variables$jbsemp, design = Dat)
svytable(~ Dat$variables$jsboss + Dat$variables$jbsemp, design = Dat)
svytable(~ Dat$variables$jstypeb + Dat$variables$jbsemp, design = Dat)

#######################################################################################
################################# 2 - Create indicator: ###############################
#######################################################################################

#* Create the indicator for both employees and the self-employed:
Dat$variables$Ind_ManagerialDuties <- case_when((Dat$variables$jbmngr == 1 | Dat$variables$jbmngr == 2) ~ 2,
                                                      Dat$variables$jsboss == 1 ~ 2,
                                                      Dat$variables$jbmngr == 3 ~ 0,
                                                      Dat$variables$jsboss == 2 ~ 0,
                                                      TRUE ~ -1)

#######################################################################################
########################## 3 - Visualisation and tabulation: ##########################
#######################################################################################

#* Then re-add filters:
JQ <- Dat |> filter(Dat$variables$index == "Quality of Work")
Employees <- Dat |> filter(Dat$variables$jbsemp == 1)
SelfEmployed <- Dat |> filter(Dat$variables$jbsemp == 2)

#* Proportional table time series:
prop.table(svytable((~Ind_ManagerialDuties + year),JQ), margin=2)
prop.table(svytable((~Ind_ManagerialDuties + year),Employees), margin=2)
prop.table(svytable((~Ind_ManagerialDuties + year),SelfEmployed), margin=2)

#######################################################################################
###################### 4 - SAVE THE INDICATOR INTO THE SURVEY: ########################
#######################################################################################

#* Saved the above as of [26.09.23]:
saveRDS(Dat, file = "0 - Dat.RData")

Dat <- readRDS("0 - Dat.RData")
Dat$variables$Ind_ManagerialDuties