
#######################################################################################
################################## 1 - CREATE JQ INDEX ################################
#######################################################################################

#* ----------- [1] Convert indicators back to doubles and recode to the correct scales. 

#* First I recode each indicator back to double, as the below code won't work for
#* factor. Some of the indicator labels change upon conversion (losing their '0' values). Note
#* that for imputed variables, you will have to convert away from a factor first to avoid it 
#* interpreting the factor levels as numbers (ie turning a 2 into a 3 because it's the third level,
#* a 0 into a 1 because it's the first level, etc). This can be done through a case_when statement.
#* These have been done but commented out below:

Dat$variables$Ind_EarningsSufficiency_NAs <- as.double(Dat$variables$Ind_EarningsSufficiency_NAs)

# Dat$variables$Ind_EarningsEquity_Imp <- case_when(Dat$variables$Ind_EarningsEquity_Imp == 0 ~ 0,
#                                                   Dat$variables$Ind_EarningsEquity_Imp == 1 ~ 1,
#                                                   Dat$variables$Ind_EarningsEquity_Imp == 2 ~ 2)
Dat$variables$Ind_EarningsEquity_Imp <- as.double(Dat$variables$Ind_EarningsEquity_Imp)

# Dat$variables$Ind_Pension_Imp <- case_when(Dat$variables$Ind_Pension_Imp == 0 ~ 0,
#                                                   Dat$variables$Ind_Pension_Imp == 1 ~ 1,
#                                                   Dat$variables$Ind_Pension_Imp == 2 ~ 2)
Dat$variables$Ind_Pension_Imp <- as.double(Dat$variables$Ind_Pension_Imp)

# Dat$variables$Ind_ContinuousEmployment_Imp <- case_when(Dat$variables$Ind_ContinuousEmployment_Imp == 0 ~ 0,
#                                            Dat$variables$Ind_ContinuousEmployment_Imp == 1 ~ 1,
#                                            Dat$variables$Ind_ContinuousEmployment_Imp == 2 ~ 2)
Dat$variables$Ind_ContinuousEmployment_Imp <- as.double(Dat$variables$Ind_ContinuousEmployment_Imp)

# Dat$variables$Ind_CompositeSecurity_Imp <- case_when(Dat$variables$Ind_CompositeSecurity_Imp == 0 ~ 0,
#                                            Dat$variables$Ind_CompositeSecurity_Imp == 2 ~ 2)
Dat$variables$Ind_CompositeSecurity_Imp <- as.double(Dat$variables$Ind_CompositeSecurity_Imp)

# Dat$variables$Ind_Autonomy_Imp <- case_when(Dat$variables$Ind_Autonomy_Imp == 0 ~ 0,
#                                            Dat$variables$Ind_Autonomy_Imp == 1 ~ 1,
#                                            Dat$variables$Ind_Autonomy_Imp == 2 ~ 2)
Dat$variables$Ind_Autonomy_Imp <- as.double(Dat$variables$Ind_Autonomy_Imp)
 
# Dat$variables$Ind_CollectiveVoice_Imp <- case_when(Dat$variables$Ind_CollectiveVoice_Imp == 0 ~ 0,
#                                            Dat$variables$Ind_CollectiveVoice_Imp == 2 ~ 2)
Dat$variables$Ind_CollectiveVoice_Imp <- as.double(Dat$variables$Ind_CollectiveVoice_Imp)

# Dat$variables$Ind_Flexibility_Imp <- case_when(Dat$variables$Ind_Flexibility_Imp == 0 ~ 0,
#                                            Dat$variables$Ind_Flexibility_Imp == 1 ~ 1,
#                                            Dat$variables$Ind_Flexibility_Imp == 2 ~ 2)
Dat$variables$Ind_Flexibility_Imp <- as.double(Dat$variables$Ind_Flexibility_Imp)

# Dat$variables$Ind_ExcessiveHours_Imp <- case_when(Dat$variables$Ind_ExcessiveHours_Imp == 0 ~ 0,
#                                            Dat$variables$Ind_ExcessiveHours_Imp == 1 ~ 1,
#                                            Dat$variables$Ind_ExcessiveHours_Imp == 2 ~ 2)
Dat$variables$Ind_ExcessiveHours_Imp <- as.double(Dat$variables$Ind_ExcessiveHours_Imp)

# Dat$variables$Ind_ManagerialDuties_Imp <- case_when(Dat$variables$Ind_ManagerialDuties_Imp == 0 ~ 0,
#                                            Dat$variables$Ind_ManagerialDuties_Imp == 2 ~ 2)
Dat$variables$Ind_ManagerialDuties_Imp <- as.double(Dat$variables$Ind_ManagerialDuties_Imp)

# Dat$variables$Ind_ShortTermProspects_Imp <- case_when(Dat$variables$Ind_ShortTermProspects_Imp == 0 ~ 0,
#                                            Dat$variables$Ind_ShortTermProspects_Imp == 1 ~ 1,
#                                            Dat$variables$Ind_ShortTermProspects_Imp == 2 ~ 2)
Dat$variables$Ind_ShortTermProspects_Imp <- as.double(Dat$variables$Ind_ShortTermProspects_Imp)

#* ----------- [2] Divide all the indicators: 

#* This should give scores of 0 (worst), 0.25 (middle) and 0.5 (best) for the categorical 
#* indicators, and 0 (worst) to 0.5 (best) for the binary indicators. Note that 
#* it's very important never to repeat the variables either side of the <-, as that will 
#* create a loop: ie re-doing  the calculation will then divide the new result by 4, 
#* then the new result by 4, etc etc:
Dat$variables$Ind_EarningsSufficiency_AF <- Dat$variables$Ind_EarningsSufficiency_NAs / 4
Dat$variables$Ind_EarningsEquity_AF <- Dat$variables$Ind_EarningsEquity_Imp / 4
Dat$variables$Ind_Pension_AF <- Dat$variables$Ind_Pension_Imp / 2
Dat$variables$Ind_ContinuousEmployment_AF <- Dat$variables$Ind_ContinuousEmployment_Imp / 4
Dat$variables$Ind_CompositeSecurity_AF <- Dat$variables$Ind_CompositeSecurity_Imp / 4
Dat$variables$Ind_Autonomy_AF <- Dat$variables$Ind_Autonomy_Imp / 4
Dat$variables$Ind_CollectiveVoice_AF <- Dat$variables$Ind_CollectiveVoice_Imp / 4
Dat$variables$Ind_Flexibility_AF <- Dat$variables$Ind_Flexibility_Imp / 4
Dat$variables$Ind_ExcessiveHours_AF <- Dat$variables$Ind_ExcessiveHours_Imp / 4
Dat$variables$Ind_ManagerialDuties_AF <- Dat$variables$Ind_ManagerialDuties_Imp / 6
Dat$variables$Ind_ShortTermProspects_AF <- Dat$variables$Ind_ShortTermProspects_Imp / 6
Dat$variables$Ind_LongTermProspects_AF <- Dat$variables$Ind_LongTermProspects / 6
Dat$variables$Ind_WorkFatalities_AF <- Dat$variables$Ind_WorkFatalities / 6
Dat$variables$Ind_WorkAccidents_AF <- Dat$variables$Ind_WorkAccidents / 6
Dat$variables$Ind_WorkIllness_AF <- Dat$variables$Ind_WorkIllness / 6

#* Quality Check [16.10.23]: Within each dimension, the maximum value should now be 1 and the 
#* minimum 0. With the exception of the Pension indicator, the maximum value in each 
#* individual indicator should be 0.5:
summary(Dat$variables$Ind_EarningsSufficiency_AF) #* [Dimension 1]
summary(Dat$variables$Ind_EarningsEquity_AF)
summary(Dat$variables$Ind_Pension_AF) #* [Dimension 2]
summary(Dat$variables$Ind_ContinuousEmployment_AF) #* [Dimension 3]
summary(Dat$variables$Ind_CompositeSecurity_AF)
summary(Dat$variables$Ind_Autonomy_AF) #* [Dimension 4]
summary(Dat$variables$Ind_CollectiveVoice_AF) 
summary(Dat$variables$Ind_Flexibility_AF) #* [Dimension 5]
summary(Dat$variables$Ind_ExcessiveHours_AF)
summary(Dat$variables$Ind_ShortTermProspects_AF) #* [Dimension 6]
summary(Dat$variables$Ind_ManagerialDuties_AF)
summary(Dat$variables$Ind_LongTermProspects_AF)
summary(Dat$variables$Ind_WorkFatalities_AF) #* [Dimension 7]
summary(Dat$variables$Ind_WorkAccidents_AF)
summary(Dat$variables$Ind_WorkIllness_AF)

#* ----------- [3] Group indicators into dimensions: 

#* Now the maximum values within each dimension equal 1, it's just a case of adding them up. 
#* I times the earnings dimension by 1.666667 to give it a weight of 1/4 of the JQ index score. 
#* When the health and safety dimension is added I will increase the weight so it's still 1/4. 
#* Note that in the Work Life Balance dimension, I times the excessive hours indicator by two for 
#* self-employed people, so that they can have the same maximum value as employees do:

Dat$variables$D1_Earnings_AF <- (Dat$variables$Ind_EarningsSufficiency_AF + Dat$variables$Ind_EarningsEquity_AF) * 2
Dat$variables$D2_Insurance_AF <- Dat$variables$Ind_Pension_AF
Dat$variables$D3_Security_AF <- Dat$variables$Ind_ContinuousEmployment_AF + Dat$variables$Ind_CompositeSecurity_AF
Dat$variables$D4_AutonomyAndVoice_AF <- Dat$variables$Ind_Autonomy_AF + Dat$variables$Ind_CollectiveVoice_AF
Dat$variables$D5_WorkLifeBalance_AF <- case_when(Dat$variables$jbsemp == 1 ~ (Dat$variables$Ind_Flexibility_AF + Dat$variables$Ind_ExcessiveHours_AF),
                                                                    Dat$variables$jbsemp == 2 ~ Dat$variables$Ind_ExcessiveHours_AF * 2)
Dat$variables$D6_Prospects_AF <- Dat$variables$Ind_ManagerialDuties_AF + Dat$variables$Ind_ShortTermProspects_AF + Dat$variables$Ind_LongTermProspects_AF                                                         
Dat$variables$D7_HealthandSafety_AF <- Dat$variables$Ind_WorkFatalities_AF + Dat$variables$Ind_WorkAccidents_AF + Dat$variables$Ind_WorkIllness_AF

#* ----------- [4] Add everything together:

Dat$variables$JQ_Index_AF_Score <- Dat$variables$D1_Earnings_AF + 
  Dat$variables$D2_Insurance_AF + Dat$variables$D3_Security_AF + 
  Dat$variables$D4_AutonomyAndVoice_AF + Dat$variables$D5_WorkLifeBalance_AF + 
  Dat$variables$D6_Prospects_AF + Dat$variables$D7_HealthandSafety_AF

#* [08.11.23] Even though the health and safety variables each have a min score of 0 and a max of 
#* 0.33, in practice nobody has scores at either extreme for all three of the indicators. This 
#* means that the minimum index score isn't 0, and the maximum index score isn't 8:
svytable(~DV_SelfEmployed + JQ_Index_AF_Score, JQ)
summary(JQ$variables$JQ_Index_AF_Score)
summary(JQ$variables$D7_HealthandSafety_AF)

#######################################################################################
########################### 5 - SAVE EVERYTHING INTO SURVEY ###########################
########################### ############################################################

#* [Update 1.09.23:] Data saved to Dat rather than JQ as of this date. Now uses the 
#* imputed datasets for each year. Latest save of the below is [25.11.23]:
# saveRDS(Dat, file = "0 - Dat.RData")

